/*
SG C Tools 1.1

(C) 1993 Steve Goldsmith
All Rights Reserved

Compiled with HI-TECH C 3.09 (CP/M-80).
*/

#include <hitech.h>
#include <vdc.h>

extern uchar  vdcScrHorz;
extern ushort vdcScrSize;
extern ushort vdcDispMem;
extern ushort vdcAttrMem;

/* fast disp page clear with any byte */

void clrscrvdc(uchar Ch)
{
  fillmemvdc(vdcDispMem,vdcScrSize,Ch);
}

/* fast attr page clear with any byte */

void clrattrvdc(uchar Attr)
{
  fillmemvdc(vdcAttrMem,vdcScrSize,Attr);
}

/* fill disp mem given x and y offset in current page */

void filldspvdc(uchar X, uchar Y, uchar CLen, uchar Ch)
{
  fillmemvdc(Y*vdcScrHorz+vdcDispMem+X,CLen,Ch);
}

/* fill attr mem given x and y offset in current page */

void fillattrvdc(uchar X, uchar Y, uchar ALen, uchar Attr)
{
  fillmemvdc(Y*vdcScrHorz+vdcAttrMem+X,ALen,Attr);
}
